SystemOrganization addCategory: #GODTestUtilities!

TestCase subclass: #TUMockTest
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODTestUtilities'!

!TUMockTest methodsFor: 'running' stamp: 'LGM 9/26/2014 18:52'!
setUp

	mock := TUMock new.! !

!TUMockTest methodsFor: 'tests' stamp: 'LGM 9/26/2014 18:53'!
testBinaryMessage
	
	"TUMockTest run: #testBinaryMessage"

	self should: [ mock + mock ] raise: MessageNotUnderstood.
	mock when: #+ do: [ :a | a ].
	self assert: mock + 1 equals: 1.
	self assert: mock + 2 equals: 2.! !

!TUMockTest methodsFor: 'tests' stamp: 'LGM 9/26/2014 18:53'!
testKeywordMessage
	
	"TUMockTest run: #testKeywordMessage"

	self should: [ mock messageKeyword: 1 ] raise: MessageNotUnderstood.
	mock when: #messageKeyword: do: [ :a | a ].
	self assert: (mock messageKeyword: 1) equals: 1.
	self assert: (mock messageKeyword: 2) equals: 2.

	self should: [ mock messageKeyword: 1 keyword: 2 ] raise: MessageNotUnderstood.
	mock when: #messageKeyword:keyword: do: [ :a :b | Array with: a with: b ].
	self assert: (mock messageKeyword: 1 keyword: 2) equals: #(1 2).
	self assert: (mock messageKeyword: 2 keyword: 1) equals: #(2 1).! !

!TUMockTest methodsFor: 'tests' stamp: 'LGM 9/26/2014 18:53'!
testUnaryMessage
	
	"TUMockTest run: #testUnaryMessage"

	self should: [ mock message ] raise: MessageNotUnderstood.
	mock when: #message do: [ 1 ].
	self assert: mock message equals: 1.! !

Object subclass: #TUMock
	instanceVariableNames: 'messageDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODTestUtilities'!

!TUMock methodsFor: 'error handling' stamp: 'LGM 9/26/2014 11:03'!
doesNotUnderstand: aMessage

	^ messageDict at: aMessage selector
		ifPresent: [ :b | b valueWithArguments: aMessage arguments ]
		ifAbsent: [ super doesNotUnderstand: aMessage ]! !

!TUMock methodsFor: 'initialize-release' stamp: 'LGM 9/26/2014 11:00'!
initialize

	messageDict := IdentityDictionary new.! !

!TUMock methodsFor: 'accessing' stamp: 'LGM 9/26/2014 11:02'!
when: selector do: aBlock

	messageDict at: selector put: aBlock! !
